/*
 * NCN_GPIO.c
 *
 *  Created on: 28-Jun-2017
 *      Author: HAddepal
 */


#include "NCN_GPIO.h"
#include <drivers/adc/adi_adc.h>
#define ADC_DEV_NUM (0u)
#define ADC_NUM_SAMPLES (100u)
#define ADI_ADC_MEMORY_SIZE (48u)
#define ADC0_IN_ADC0_IN0_PORTP2_MUX  ((uint16_t) ((uint16_t) 1<<6))

	ADI_ADC_HANDLE hDevice;
                              /* Memory Required for adc driver */
	static uint16_t ADC_DataBuffer[ADC_NUM_SAMPLES] = {0};							/* ADC Data Buffer */
	void usleep(uint32_t usec);
	float p;

static uint8_t DeviceMemory[ ADI_ADC_MEMORY_SIZE ];

/* Approximately wait for minimum 1 usec */
void usleep(uint32_t usec)
{
    volatile int y = 0;
    while (y++ < usec) {
        volatile int x = 0;
        while (x < 16) {
        x++;
        }
    }
}

void pinMode(unsigned char pot, unsigned char direction){
	*((volatile uint32_t *)REG_GPIO2_CFG) = ADC0_IN_ADC0_IN0_PORTP2_MUX;
}

unsigned int analogRead(unsigned char pin) {
	 ADI_ADC_BUFFER Buffer;
	    bool bCalibrationDone = false;
	    bool boo=false;
	    int q=0;

	    adi_adc_Open(ADC_DEV_NUM, DeviceMemory, sizeof(DeviceMemory), &hDevice);	 /* Open the ADC device */
	    adi_adc_PowerUp (hDevice, true);											/* Power up ADC */
	    adi_adc_SetVrefSource (hDevice, ADI_ADC_VREF_SRC_VBAT);				/* Set ADC reference Voltage=2.50 V*/
	    adi_adc_EnableADCSubSystem (hDevice, true);									/* Enable ADC sub system */

	    usleep (5000);																 /* Wait for 5.0ms */

	    adi_adc_StartCalibration (hDevice);											/* Start calibration */

	    /* Wait until calibration is done */
	    while (!bCalibrationDone)
	    {
	        adi_adc_IsCalibrationDone (hDevice, &bCalibrationDone);
	    }


	    adi_adc_SetDelayTime ( hDevice, 10);                              /* Set the delay time */
	    adi_adc_SetAcquisitionTime ( hDevice, 10);                        /* Set the acquisition time*/

	    /* Populate the buffer structure */

	    Buffer.nBuffSize = sizeof(ADC_DataBuffer);
	    Buffer.nChannels = ADI_ADC_CHANNEL_0;
	    Buffer.nNumConversionPasses = ADC_NUM_SAMPLES;
	    Buffer.pDataBuffer = ADC_DataBuffer;

	    adi_adc_SubmitBuffer (hDevice, &Buffer);						/* Submit the buffer to the driver */
	    adi_adc_Enable (hDevice, true);									/* Enable the ADC */
	    while(1){
	    adi_adc_IsBufferAvailable(hDevice,&boo);

	    ADI_ADC_BUFFER pAdcBuffer;
	    pAdcBuffer.pDataBuffer = ADC_DataBuffer;                        /*Get the value stored inside the Buffer*/
	    if(boo){
	         adi_adc_GetBuffer (hDevice, &pAdcBuffer);
	         break;
	    }
	    }
	    q=ADC_DataBuffer[0];
	    adi_adc_Enable (hDevice, false);								/* Disable the ADC */
	    adi_adc_Close (hDevice);
	    return(q);
}
